---
title: ':target-within'
slug: 'Web/CSS/:target-within'
---
<div>{{CSSRef}}{{SeeCompatTable}}</div>

<p>The <strong><code>:target-within</code></strong> <a href="/en-US/docs/Web/CSS">CSS</a> <a href="/en-US/docs/Web/CSS/Pseudo-classes">pseudo-class</a> represents an element that is a target element or <em>contains</em> an element that is a target. A target element is a unique element with an <code><a href="/en-US/docs/Web/HTML/Global_attributes#attr-id">id</a></code> matching the URL's fragment. In other words, it represents an element that is itself matched by the {{CSSxRef(":target")}} pseudo-class or has a descendant that is matched by <code>:target</code>. (This includes descendants in <a href="/en-US/docs/Web/Web_Components/Shadow_DOM">shadow trees</a>.)</p>

<pre class="brush: css no-line-numbers notranslate">/* Selects a &lt;div&gt; when one of its descendants is a target */
div:target-within {
  background: cyan;
}
</pre>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">{{CSSSyntax}}</pre>

<h2 id="Examples">Examples</h2>

<h3 id="Highlighting_an_article">Highlighting an article</h3>

<p>The <code>:target-within</code> pseudo-class can be used to highlight the article if anything inside it has been directly linked to. The <code>:target</code> pseudo-class is also being used to show which item has been targetted. </p>

<h4 id="HTML">HTML</h4>

<pre class="brush: html notranslate">&lt;h3&gt;Table of Contents&lt;/h3&gt;
&lt;ol&gt;
 &lt;li&gt;&lt;a href="#p1"&gt;Jump to the first paragraph!&lt;/a&gt;&lt;/li&gt;
 &lt;li&gt;&lt;a href="#p2"&gt;Jump to the second paragraph!&lt;/a&gt;&lt;/li&gt;

&lt;/ol&gt;

&lt;article&gt;

&lt;h3&gt;My Fun Article&lt;/h3&gt;
&lt;p id="p1"&gt;You can target &lt;i&gt;this paragraph&lt;/i&gt; using a
  URL fragment. Click on the link above to try out!&lt;/p&gt;
&lt;p id="p2"&gt;This is &lt;i&gt;another paragraph&lt;/i&gt;, also accessible
  from the links above. Isn't that delightful?&lt;/p&gt;
&lt;/article&gt;
</pre>

<h4 id="CSS">CSS</h4>

<pre class="brush: css notranslate">article:target-within {
  background-color: gold;
}

<code>/* Add a pseudo-element inside the target element */
p:target::before {
  font: 70% sans-serif;
  content: "►";
  color: limegreen;
  margin-right: .25em;
}

/* Style italic elements within the target element */
p:target i {
  color: red;
}</code></pre>

<h4 id="Result">Result</h4>

<div>{{EmbedLiveSample('Examples', 500, 300)}}</div>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("CSS4 Selectors", "#the-target-within-pseudo", ":target-within")}}</td>
   <td>{{Spec2("CSS4 Selectors")}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("css.selectors.target-within")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{CSSxRef(":target")}}</li>
</ul>
